#include<bits/stdc++.h>
using namespace std;
int n;
vector<short> ch[1000006];
int main () {
    cin >> n;
    for(int i = 0 ; i < n; i++){
        int ind, m;
        cin >> ind >> m;
        if(m == 0){
            for(int j = 0; j < ch[ind].size() - 1; j++){
                ch[i + 1].push_back(ch[ind][j]);
            }
        }else{
            for(int j = 0; j < ch[ind].size(); j++){
                ch[i + 1].push_back(ch[ind][j]);
            }
            ch[i + 1].push_back(m);
        }
    }
    long long sum = 0;
    for(int i = 0 ; i < n; i++){
        for(int j = 0 ; j < ch[i + 1].size(); j++){
            sum += ch[i + 1][j];
        }
    }
    cout << sum << "\n";



    return 0;
}